__doc__ = """Subscription Mix-in Class"""

__version__ = '1.0'

from Globals import HTMLFile, HTML
from Globals import InitializeClass
from Products.WISE import WISEClass
from AccessControl import ClassSecurityInfo

class SubscriptionItem(WISEClass.WISEClass):
        """Subscription Mix-in Class"""

        # Security Module
        security = ClassSecurityInfo()

        # Default security policy
        security.declareObjectProtected('Manager')

        # Protected methods
        security.declareProtected('View', 'subscribe')
        security.declareProtected('View', 'subscriptions')
        security.declareProtected('View', 'addSubscription')
        security.declareProtected('View', 'hasSubscription')
        security.declareProtected('View', 'removeSubscription')
        security.declareProtected('View', 'subscription_mail_list')
        security.declareProtected('View', 'subscription_title')
	
       	subscribe = HTMLFile("subscribe", globals())

	def __init__(self):
		"""build subscription"""
		self._subscriptions = {}

	def subscription_title(self):
		"""overide for subscription mesasges"""
		return ""
		
	def hasSubscription(self, email):
		"""returns whether the email is in this object"""
		return self._subscriptions.has_key(email)

	def addSubscription(self, email, name, REQUEST=None):
		"""adds a subscription to this item"""
		self._subscriptions[email] = name
		self._p_changed = 1
		
		if REQUEST is not None:
			REQUEST.RESPONSE.redirect("index_html")

	def removeSubscription(self, email, REQUEST=None):
		"""removes a subscription from this item"""
		# ignore if subscription doesn't exist
		try:
			del self._subscriptions[email]
			self._p_changed = 1
			removed = 1
		except:
			removed = 0

		if REQUEST is not None:
			REQUEST.RESPONSE.redirect("index_html")

		return removed

	def subscriptions(self):
		"""returns emails and subscriptions"""
		# return copy of subscription dictionary
		return self._subscriptions.copy()

	def subscription_mail_list(self, merge_dict={}):
		"""returns a line to be used in an email header"""
		mail_dict = self.subscriptions()
		mail_dict.update(merge_dict)
		# build list of formatted entries
		mail_list = [ '"%s" <%s>' % (name, email) \
			      for email, name in mail_dict.items() ]
				
		return ', '.join(mail_list)
		
	def subscription_mail_list2(self, merge_dict={}):
		"""returns a list of subscribers"""
		mail_dict = self.subscriptions()
		mail_dict.update(merge_dict)
		# build list of formatted entries
		mail_list = [ '"%s" - %s <br>' % (name, email) \
			      for email, name in mail_dict.items() ]
				
		return ''.join(mail_list)

